unit RegleaCalculs_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, ExtCtrls, Menus  ;
 
type
  TForm1 = class(TForm)
    Image_corps: TImage;
    Image_glissiere: TImage;
    Image_reticul: TImage;
    PopupMenu1: TPopupMenu;
    ColorDialog1: TColorDialog;
    Couleur1: TMenuItem;
    Function AutoResizeImage(Image: TImage; W,H: Integer): Boolean;
    procedure FormActivate(Sender: TObject);
    procedure Image_glissiereMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Image_corpsDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Image_corpsDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Image_reticulMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image_glissiereDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure Image_glissiereDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure Image_reticulDblClick(Sender: TObject);
    procedure Couleur1Click(Sender: TObject);
    procedure Deplace(Control: TObject; X, Y: Integer);
    procedure SiToucheRecouvre(Shape: TShape; X,Y: Integer);
    procedure InitialiseTShapePos;
    procedure FormCreate(Sender: TObject);

    
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

  ShapePos = record   // structure de type record avec paramtres de position
    Top: Integer;
    Left: Integer;
    Center: TPoint;   // Center.x et Center.y, voir Aide En Ligne "TPoint"
  end;

var
  Form1: TForm1;
  largeur ,Hauteur ,raport : integer;

  TShapePos: array[1..5] of ShapePos; // tableau de record



implementation
uses Math;
{$R *.dfm}

function TForm1.AutoResizeImage(Image: TImage; W,H: Integer): Boolean;
var
  X, Y: Integer;
  R: Variant;
begin // redimentionne une image
  try
    with Image do begin
      X:=Picture.Width;
      Y:=Picture.Height;
      R:= X / Y;
      if H>0
      then
        begin
          if (W / H)>=R
          then begin Height:=H; Width:=H*R; end
          else begin Width:=W; Height:=W / R; end;
          Stretch:=True;
        end;
    end;
    Result:=True;
  except
    Result:=False
  end;
end;
procedure TForm1.FormActivate(Sender: TObject);
begin
  largeur :=  Image_corps.Width ;
  Hauteur :=  Image_corps.Height;
  raport  :=  Image_corps.Width div Image_corps.Height  ;

  AutoResizeImage( Image_corps, 500, 400 *raport )   ;
  AutoResizeImage( Image_glissiere, 500, 400 *raport ) ;

  AutoResizeImage( Image_reticul, 500  , 500 div raport   )   ;

  Image_glissiere.Top := Image_corps.Top + (Image_corps.Height div 2) -(Image_glissiere.height div 2);
end;

procedure TForm1.Image_glissiereMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     Image_glissiere.Tag := x ;
  //   caption := inttostr(x);
     image_glissiere.BeginDrag(true);
end;               

procedure TForm1.Image_corpsDragDrop(Sender, Source: TObject; X, Y: Integer);
begin

//    caption :=  Tcomponent(Sender).Name +'   ' + Tcomponent(Source).Name ;
   // image_glissiere.Left := x - Image_glissiere.Tag  ;

    TImage(Source).Left :=  x - Image_glissiere.Tag  ;
    //Image_reticul.Transparent := false;
    Image_reticul.Visible := true;
end;

procedure TForm1.Image_corpsDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
   Accept := true;
end;

procedure TForm1.Image_reticulMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if Sender is TControl then             // normalement inutile
    if (Sender as TControl).Visible then  // normalement inutile
      (Sender as TControl).BringToFront;  // amne au premier plan

//

  if ssLeft  in  Shift	 then
   image_reticul.BeginDrag(true);
end;

procedure TForm1.Image_glissiereDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
    Image_reticul.Left :=  x   ;
end;

procedure TForm1.Image_glissiereDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
Accept := true;
end;

procedure TForm1.Image_reticulDblClick(Sender: TObject);
begin


      ///Image_reticul.Transparent := not  Image_reticul.Transparent ;

    //   Image_reticul.Picture.Bitmap.TransparentColor  := Image_reticul.Picture.Bitmap.canvas.pixels[50,50];
     //Image_reticul.Picture.Bitmap.TransparentColor  := ColorDialog1.Color ;

   //  Form1.Canvas.Draw(0,0,Image_reticul.Picture.Bitmap);

   //   Image_reticul.Picture.Bitmap.TransparentMode :=tmAuto;

   //  Form1.Canvas.Draw(50,50,Image_reticul.Picture.Bitmap);

end;

procedure TForm1.Couleur1Click(Sender: TObject);
begin
   ColorDialog1.Execute
end;


{ Si contact entre le Shape dplac et un autre Shape, il y a superposition }
procedure TForm1.SiToucheRecouvre(Shape: TShape; X,Y: Integer);
{Distance = carr de la distance entre les centres, dtermine l'attraction.
Est gal en fait au carr du diamtre, soit ici: 65 puissance 2 = 4025}
const Distance: Word = 4025;
var i: Integer;
    Center: TPoint;
    CarreX, CarreY, CarreH: Double; // ou Extended
    PlusPres: Double;         // pour stocker la plus petite distance trouve
    Index: Word;              // 65535 objets... a devrait suffire
    Touche: Boolean;          // 2 shapes se touchent ?
begin

  with Shape do   // vite les rptitions genre "Shape.Left + Shape.Width"
  begin
        
      Center.x := Left + (Width div 2);    // coordonn x du centre
      Center.y := Top  + (Height div 2);   // coordonn y du centre
    PlusPres := Distance;               // initialisation
    Touche := False;                    // initialisation condition
    for i := 1 to 5 do                  // pour tous les Shapes...
    begin
      if i <> Tag then                  // si ce n'est pas le Shape dplac...
      begin
        { on teste la distance entre les centres }
        CarreX := IntPower(Abs(Center.x - TShapePos[i].Center.x), 2);
        CarreY := IntPower(Abs(Center.y - TShapePos[i].Center.y), 2);
        CarreH := CarreX + CarreY;
        { si distance Ok et pas de distance plus petite... }
        if (CarreH < Distance) and not (CarreH > PlusPres)
        then
        begin
          PlusPres := CarreH;   // c'est la distance la plus petite
          Index := i;           // identifie dans le tableau le Shape concern
          Touche := True;       // la condition d'attraction est remplie
        end;
      end;
    end;
    if Touche then  // si le Shape qu'on dplace touche un autre Shape...
    begin
      Top := TShapePos[Index].Top;    // on le place  la mme position Top
      Left := TShapePos[Index].Left;  // et position Left
    end;
    { Dans tous les cas, mise  jour des coordonnes du Shape dplac }
    TShapePos[Tag].Top := Top;
    TShapePos[Tag].Left := Left;
    TShapePos[Tag].Center.x := Left + (Width div 2);
    TShapePos[Tag].Center.y := Top + (Height div 2);
  end;
end;

 // Dplacement du Control avec limitation par les bords du Parent du Control }
procedure TForm1.Deplace(Control: TObject; X, Y: Integer);
const Marge: Byte = 0;  // Marge ventuelle (max 255)
var
  ControlPos, MousePos: TPoint; // position objet  dplacer, pointeur souris
  DiffX, DiffY: Integer;        // diffrence position pointeur souris et objet
  XMax, Ymax: Integer;          // limite de dplacement  droite et en bas
begin
  Application.ProcessMessages;  // excution d'une ventuelle instruction prcdente
  GetCursorPos(MousePos);       // rcupre position pointeur
  with Control as TControl do   // avec Control en tant que TControl
  begin
    XMax := Parent.Width - Width - Marge;     // dplacement maximum  droite
    YMax := Parent.Height - Height - Marge;   // dplacement maximum en bas
    Windows.ScreenToClient(Parent.Handle, MousePos);
    DiffX := MousePos.X - Left;
    DiffY := MousePos.Y - Top;
    while DragDetect(Parent.Handle, ControlPos) do  // tant que dure le dplacement...
    begin
      GetCursorPos(MousePos);       // position du pointeur de souris
      Windows.ScreenToClient(Parent.Handle, MousePos); // convertit position, voir aide F1
      { on va empcher la sortie du Control de son parent }
      Left := MousePos.X - DiffX;   // POSITION AXE HORIZONTAL X
      if Left < 0 then              // sortie  gauche...
        Left := 0
      else if Left > XMax then      // sortie  droite...
        Left := XMax;
      Top := MousePos.Y - DiffY;    // POSITION AXE VERTICAL Y
      if Top < 0 then               // sortie en haut...
        Top := 0
      else if Top > YMax then       // sortie en bas...
        Top := YMax;
      { permet la visualisation du dplacement }
      Application.ProcessMessages;

      { Test de la distance entre le Shape dplac et un autre Shape }
      SiToucheRecouvre(Control as TShape, Left, Top);
    end;
  end;
end;
{ Initialisation du Tableau de Record contenant les paramtres de position }
procedure TForm1.InitialiseTShapePos;
var i: Integer;
    Index: Integer; // pas indispensable, mais pour la clart du code
begin

  for i := 0 to ComponentCount -1 do  // composants de la fiche (0..n-1)
  begin
    if Components[i] is TImage then   // TShape si ce composant est un TShape
    begin
      with Components[i] as TImage do //  TShape  avec ce composant...
      begin
        Index := Tag;                 // le tag donne l'index du tableau
        { On rcupre les params de position pour les stocker dans le tableau }
        TShapePos[Index].Top := Top;
        TShapePos[Index].Left := Left;
        TShapePos[Index].Center.x := Left + (Width div 2);
        TShapePos[Index].Center.y := Top + (Height div 2);
      end;
    end;
  end;
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
   Form1.DoubleBuffered := True;  // pour la fluidit du dplacement
   InitialiseTShapePos;           // initialisation du tableau, voir en haut
   Image_reticul.Picture.Bitmap.TransparentColor  := clWhite;

end;

end.
